#include "ovdisis.h"

void fix_linex(RECT *);
void fix_liney(RECT *);

int do_pointclip(RECT *cor, RECT *clip)
{
  if((cor->x1 < clip->x1) || (cor->x1 > clip->x2) ||
     (cor->y1 < clip->y1) || (cor->y1 > clip->y2))
    return 0;
  else
    return 1;
}

/* This HAS to be possible in a more simple way! */
int do_lineclip(RECT *cor, RECT *clip)
{
  fix_linex(cor);

  /* check if totally out of it */
  if(((cor->x1 < clip->x1) && (cor->x2 < clip->x1)) ||
     ((cor->x1 > clip->x2) && (cor->x2 > clip->x2)) ||
     ((cor->y1 < clip->y1) && (cor->y2 < clip->y1)) ||
     ((cor->y1 > clip->y2) && (cor->y2 > clip->y2)))
    return 0;

  if(cor->x1 == cor->x2)
    { /* Vertical line */
      if(cor->y1 < clip->y1)
	{
	  if(cor->y2 < clip->y1)
	    return 0;
	  else
	    {
	      cor->y1 = clip->y1;
	      cor->y2 = min(cor->y2, clip->y2);
	    }
	}
      else
	{
	  if(cor->y1 > clip->y2)
	    return 0;
	  else
	    cor->y2 = min(cor->y2, clip->y2);
	}
    }
  else if(cor->y1 == cor->y2)
    { /* Horizontal line */
      if(cor->x1 < clip->x1)
	{
	  if(cor->x2 < clip->x1)
	    return 0;
	  else
	    {
	      cor->x1 = clip->x1;
	      cor->x2 = min(cor->x2, clip->x2);
	    }
	}
      else
	{
	  if(cor->x1 > clip->x2)
	    return 0;
	  else
	    cor->x2 = min(cor->x2, clip->x2);
	}
    }
  else
    { /* Non straight line */
      int t1,t2;
      float k;

      /* Check again if outside */
      fix_liney(cor);
      k = ((float)(cor->x2 - cor->x1) / (float)(cor->y2 - cor->y1));
      t1 = cor->x1 - (int)((float)(cor->y1 - clip->y1) * k);
      t2 = cor->x2 - (int)((float)(cor->y2 - clip->y2) * k);
      if(((t1 > clip->x2) && (t2 > clip->x2)) ||
	 ((t1 < clip->x1) && (t2 < clip->x1)))
	return 0;

      fix_linex(cor);
      k = ((float)(cor->y2 - cor->y1) / (float)(cor->x2 - cor->x1));
      t1 = cor->y1 - (int)((float)(cor->x1 - clip->x1) * k);
      t2 = cor->y2 - (int)((float)(cor->x2 - clip->x2) * k);
      if(((t1 > clip->y2) && (t2 > clip->y2)) ||
	 ((t1 < clip->y1) && (t2 < clip->y1)))
	return 0;


      if(cor->x1 < clip->x1)
	{
	  cor->y1 += (int)((float)(clip->x1 - cor->x1) * k);
	  cor->x1 = clip->x1;
	}
      if(cor->y1 < clip->y1)
	{
	  cor->x1 += (int)((float)(clip->y1 - cor->y1) / k);
	  cor->y1 = clip->y1;
	}
      else if(cor->y1 > clip->y2)
	{
	  cor->x1 += (int)((float)(clip->y2 - cor->y1) / k);
	  cor->y1 = clip->y2;
	}
      
      if(cor->x2 > clip->x2)
	{
	  cor->y2 += (int)((float)(clip->x2 - cor->x2) * k);
	  cor->x2 = clip->x2;
	}
      if(cor->y2 > clip->y2)
	{
	  cor->x2 += (int)((float)(clip->y2 - cor->y2) / k);
	  cor->y2 = clip->y2;
	}
      else if(cor->y2 < clip->y1)
	{
	  cor->x2 += (int)((float)(clip->y1 - cor->y2) / k);
	  cor->y2 = clip->y1;
	}

    }
  return 1;
}

void fix_rect(RECT *cor)
{
  RECT t;

  t.x1 = min(cor->x1, cor->x2);
  t.y1 = min(cor->y1, cor->y2);
  cor->x2 = max(cor->x1, cor->x2);
  cor->y2 = max(cor->y1, cor->y2);
  cor->x1 = t.x1;
  cor->y1 = t.y1;
}

void fix_linex(RECT *cor)
{
  int t;

  if(cor->x2 < cor->x1)
    {
      t = cor->x1;
      cor->x1 = cor->x2;
      cor->x2 = t;
      t = cor->y1;
      cor->y1 = cor->y2;
      cor->y2 = t;
    }
}

void fix_liney(RECT *cor)
{
  int t;

  if(cor->y2 < cor->y1)
    {
      t = cor->y1;
      cor->y1 = cor->y2;
      cor->y2 = t;
      t = cor->x1;
      cor->x1 = cor->x2;
      cor->x2 = t;
    }
}
